# script to build the BiDi version, known to work on 
# Red Hat 7.1

rm -rf motif motif_build

if [ ! -r openmotif2.1.30.tar.gz ]
then
   printf "Cannot find Open Motif 2.1.30 tar archive in current directory\naborting"
   exit 1
fi

tar zxvf openmotif2.1.30.tar.gz
cat patches1-5+bidi.patch|patch -p0 -d . >patch.log

mkdir motif_build
cd motif_build
lndir ../motif
mkdir -p imports/x11
cd imports/x11
ln -s /usr/X11R6/bin
ln -s /usr/X11R6/lib
ln -s /usr/X11R6/include
cd ../../lib/Xm

if [ ! -r /usr/lib/liblayout.so ]
then
   printf "You do not appear to have the layout_engine installed\naborting..."
   exit 1
fi

cd ../..
make World 2>log

printf "To install, cd to motif_build first\n"
printf "\tcd motif_build\n"
printf "then execute\n"
printf "\tmake install\n"
