/***********************************************************



((c) Copyright 2002 IBM. All Rights Reserved)." Licensed by IBM under the X license."

 COPYRIGHT AND PERMISSION NOTICE


Copyright (c) 2002 IBM Corporation

All rights reserved.

Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, and/or sell copies of the Software, and to permit persons
to whom the Software is furnished to do so, provided that the above
copyright notice(s) and this permission notice appear in all copies of
the Software and that both the above copyright notice(s) and this
permission notice appear in supporting documentation.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT
OF THIRD PARTY RIGHTS. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
HOLDERS INCLUDED IN THIS NOTICE BE LIABLE FOR ANY CLAIM, OR ANY SPECIAL
INDIRECT OR CONSEQUENTIAL DAMAGES, OR ANY DAMAGES WHATSOEVER RESULTING
FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

Except as contained in this notice, the name of a copyright holder
shall not be used in advertising or otherwise to promote the sale, use
or other dealings in this Software without prior written authorization
of the copyright holder.

X Window System is a trademark of The Open Group


******************************************************************/

 
/*
 *  This is the private header file for layout services.
 */
#ifndef _LAYOUT_INT_H_
#define _LAYOUT_INT_H_

/* In case if TRUE or FALSE are defined */
#if     !defined(TRUE) || ((TRUE) != 1)
#define TRUE    1
#endif   
#if     !defined(FALSE) || ((FALSE) != 0)
#define FALSE   0
#endif   


typedef struct _LayoutObject *LayoutObj;                /* Private name */



typedef struct {
    LayoutObject (*create)(
#if NeedFunctionPrototypes
        LayoutObj, LayoutValues
#endif
        );

    int (*destroy)(
#if NeedFunctionPrototypes
        LayoutObj
#endif
        );
        
    int (*getvalues)(
#if NeedFunctionPrototypes
        LayoutObj, LayoutValues, int *
#endif
        );
        
    int (*setvalues)(
#if NeedFunctionPrototypes
        LayoutObj, LayoutValues, int *
#endif
        );
        
    int (*transform)(
#if NeedFunctionPrototypes
        LayoutObj, const char *, size_t , void *,
        size_t *, size_t *, size_t *, unsigned char *, size_t *
#endif
        );
        
    int (*wcstransform)(
#if NeedFunctionPrototypes
        LayoutObj, const wchar_t *, size_t , void *,
        size_t *, size_t *, size_t *, unsigned char *, size_t *
#endif
        );
        
} LayoutMethodsRec, *LayoutMethods;


typedef struct {
    char                        *locale_name;
    
    LayoutTextDescriptor        orientation;
    LayoutTextDescriptor        context;
    LayoutTextDescriptor        type_of_text;
    LayoutTextDescriptor        implicit_alg;
    LayoutTextDescriptor        swapping;
    LayoutTextDescriptor        numerals;
    LayoutTextDescriptor        text_shaping;
    BooleanValue                active_dir;
    BooleanValue                active_shape_editing;
    char                        *shape_charset;
    int                         shape_charset_size;
    unsigned long               in_out_text_descr_mask;
    unsigned long               in_only_text_descr;
    unsigned long               out_only_text_descr;
    int                         check_mode;
    LayoutEditSize              shape_context_size;
} LayoutCoreRec, *LayoutCore;

typedef struct _LayoutObject {
    LayoutMethods         methods;         /* methods of this CTL Object */
    LayoutCoreRec         core;                   /* data of this CTL Object */
    void                  *private_data;   /* Private data of locale-dependent object */

} LayoutObjectRec;


#endif /* _LAYOUT_INT_H_ */
