/***********************************************************



((c) Copyright 2002 IBM. All Rights Reserved)." Licensed by IBM under the X license."

 COPYRIGHT AND PERMISSION NOTICE


Copyright (c) 2002 IBM Corporation

All rights reserved.

Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, and/or sell copies of the Software, and to permit persons
to whom the Software is furnished to do so, provided that the above
copyright notice(s) and this permission notice appear in all copies of
the Software and that both the above copyright notice(s) and this
permission notice appear in supporting documentation.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT
OF THIRD PARTY RIGHTS. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
HOLDERS INCLUDED IN THIS NOTICE BE LIABLE FOR ANY CLAIM, OR ANY SPECIAL
INDIRECT OR CONSEQUENTIAL DAMAGES, OR ANY DAMAGES WHATSOEVER RESULTING
FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

Except as contained in this notice, the name of a copyright holder
shall not be used in advertising or otherwise to promote the sale, use
or other dealings in this Software without prior written authorization
of the copyright holder.

X Window System is a trademark of The Open Group

******************************************************************/


#ifndef _Lc_Layout_
#define _Lc_Layout_

#include <sys/types.h>
 /**************************************************************************/
 /*                             CONSTANTS                                  */ 
 /**************************************************************************/

#define TRUE	1
#define FALSE	0

/* 
 * Define Layout Values type used for LayoutSet/GetValues()
  *  Types are defined as 32 bit int split into 2 parts
  *  Lower 16 bits - LayoutTextDescriptor
  *  Higher 16 bits - any other type
  */
#define AllTextDescptors	0x0000ffff
#define Orientation             0x00000001
#define TypeOfText              0x00000002
#define Swapping                0x00000004
#define Numerals                0x00000008
#define TextShaping             0x00000010
#define ArabicSpecialShaping    0x00000020
#define ArabicOneCellShaping    0x00000040
#define WordBreak               0x00000080
#define BidiType                0x00000100

#define ActiveShapeEditing	(0x01<<16)
#define ActiveBidirection	(0x02<<16)
#define ShapeCharset		(0x03<<16)
#define ShapeCharsetSize	(0x04<<16)
#define ShapeContextSize	(0x05<<16)
#define InputMode   		(0x07<<16)

 /* constant to select a specified bit in the BIDI Attribute */

#define TEXT_VISUAL     	0x00000000
#define TEXT_IMPLICIT   	0x01000000
#define TEXT_EXPLICIT   	0x02000000

#define BIDI_DEFAULT   		0x00000000
#define BIDI_UCS       		0x04000000

#define ORIENTATION_LTR      	0x00000000
#define ORIENTATION_RTL      	0x00010000
#define ORIENTATION_CONTEXT_LTR 0x00020000
#define ORIENTATION_CONTEXT_RTL 0x00030000

#define NUMERALS_NOMINAL      	0x00000000
#define NUMERALS_NATIONAL       0x00002000
#define NUMERALS_CONTEXTUAL     0x00003000

#define BREAK              	0x00000200
#define NO_BREAK             	0x00000000

#define SWAPPING              	0x00000100
#define NO_SWAPPING             0x00000000

#define ONECELL_SEEN       	0x00000080
#define TWOCELL_SEEN       	0x00000000

#define TEXT_STANDARD       	0x00000000
#define TEXT_SPECIAL       	0x00000040
#define TEXT_COMPOSED           0x00000020

#define TEXT_SHAPED   		0x00000000
#define TEXT_NOMINAL      	0x00000010
#define TEXT_INITIAL     	0x00000011
#define TEXT_MIDDLE      	0x00000012
#define TEXT_FINAL       	0x00000013
#define TEXT_ISOLATED    	0x00000014
 
#define EDITINPUT               0
#define EDITREPLACE             1

 /**************************************************************************/
 /*                            STRUCTURES                                  */ 
 /**************************************************************************/

typedef char *LayoutObject;
 
typedef char BooleanValue;

typedef struct {
		  int name;
		  caddr_t value;
		}LayoutValueRec, *LayoutValues;

typedef struct {
			int front;   /* previous chars */
			int back;    /* succeeding chars */
		}LayoutEditSizeRec, *LayoutEditSize;


typedef struct {
		  int in;	/* input buffer description */
		  int out;	/* output description */
	       }LayoutTextDescriptorRec, *LayoutTextDescriptor;

#endif _Lc_Layout_
