/***********************************************************



((c) Copyright 2002 IBM. All Rights Reserved)." Licensed by IBM under the X license."

 COPYRIGHT AND PERMISSION NOTICE


Copyright (c) 2002 IBM Corporation

All rights reserved.

Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, and/or sell copies of the Software, and to permit persons
to whom the Software is furnished to do so, provided that the above
copyright notice(s) and this permission notice appear in all copies of
the Software and that both the above copyright notice(s) and this
permission notice appear in supporting documentation.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT
OF THIRD PARTY RIGHTS. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
HOLDERS INCLUDED IN THIS NOTICE BE LIABLE FOR ANY CLAIM, OR ANY SPECIAL
INDIRECT OR CONSEQUENTIAL DAMAGES, OR ANY DAMAGES WHATSOEVER RESULTING
FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

Except as contained in this notice, the name of a copyright holder
shall not be used in advertising or otherwise to promote the sale, use
or other dealings in this Software without prior written authorization
of the copyright holder.

X Window System is a trademark of The Open Group


******************************************************************/

#ifndef _DEFAULT_H_
#define _DEFAULT_H_
#include <iconv.h>
#include "../layout/layout.h"


/* Haytham */
/* This part is private to the Default part and is added for downword */
/* compatibility with previous versions.                             */

typedef struct {

        int (*arabicGetValues) (
#if NeedFunctionPrototypes
        LayoutObj, LayoutValues, int *
#endif
        );
        
        int (*arabicSetValues) (
#if NeedFunctionPrototypes
        LayoutObj, LayoutValues, int *
#endif
        );

        int (*arabicEditShape) (
#if NeedFunctionPrototypes
                LayoutObj,
                BooleanValue,
                size_t      *,
                const char  *,
                size_t      *,
                void        *,
                size_t      *
#endif
        );

        int (*arabicShapeBoxChars) (
#if NeedFunctionPrototypes
        LayoutObj, const char *, const size_t, char *
#endif
        );

} DefaultMethodsRec, *DefaultMethods;

typedef struct {
        
        DefaultMethods  methods;
        int compc;
        void *locale_data;

} DefaultRec, *Default;

#endif
