/***********************************************************



((c) Copyright 2002 IBM. All Rights Reserved)." Licensed by IBM under the X license."

 COPYRIGHT AND PERMISSION NOTICE


Copyright (c) 2002 IBM Corporation

All rights reserved.

Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, and/or sell copies of the Software, and to permit persons
to whom the Software is furnished to do so, provided that the above
copyright notice(s) and this permission notice appear in all copies of
the Software and that both the above copyright notice(s) and this
permission notice appear in supporting documentation.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT
OF THIRD PARTY RIGHTS. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
HOLDERS INCLUDED IN THIS NOTICE BE LIABLE FOR ANY CLAIM, OR ANY SPECIAL
INDIRECT OR CONSEQUENTIAL DAMAGES, OR ANY DAMAGES WHATSOEVER RESULTING
FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

Except as contained in this notice, the name of a copyright holder
shall not be used in advertising or otherwise to promote the sale, use
or other dealings in this Software without prior written authorization
of the copyright holder.

X Window System is a trademark of The Open Group

******************************************************************/

#include <iconv.h>
#include <stdlib.h>
#include "uc_types.h"
#include "uc_data.h"

#define ARABIC_CHARSET1     "IBM1046"
#define ARABIC_CHARSET2     "ISO-8859-6"

#define HEBREW_CHARSET1     "IBM856"
#define HEBREW_CHARSET2     "ISO-8859-8"


#define NUMERALS_NONE       0x00001000

#define LRE                 0x202A
#define LRO                 0x202D
#define RLE                 0x202B
#define RLO                 0x202E
#define PDF                 0x202C

typedef struct {
    int             orient_in;
    int             orient_out;
    int             txtShp_flag;
    int             formShp;
    int             order_flag;
    int             boc_flag;
    int             size;
    int             size_out;
    int             compc;
    int             backward;
    int             orient;
    char           *codeset;
    int             wordbreak;
    int             num_flag;
    int             flip_flag;
    int             symmetric;
    int             num;
    PUNI_CHAR       buffer_in;
    PUNI_CHAR       buffer_out;
    unsigned short  Tables;
    unsigned char  *A_level;
    size_t         *SrcToTrgMap;
    size_t         *TrgToSrcMap;
}   ICSPARAMRec;

typedef ICSPARAMRec *PICSPARAMRec;

typedef struct {
    int             ix;
    int             basLev;
    int             outLev;
    int             curLev;
    int             addLev;
    int             impLev;
    int             impSta;
    int             araLet;
    int             Shaping;
    int             Compac;
    int             linsepPos;
    int             condPos;
    UNI_CHAR        wTarget;
    UBA_TYPE        xType;
    UBA_TYPE        pType;
    LstackP         Lstack;
    int             indexOfStack;
    int             over;
    int             noOp;
    int             newCL;
}               UCB2V;
typedef UCB2V  *PUCB2V;

int 
UCB2VIS(PICSPARAMRec);
int 
UCQSPAC(UNI_CHAR);
UNI_CHAR 
UCQSYMM(UNI_CHAR);
UBA_TYPE 
getchtype(UNI_CHAR);
UNI_CHAR 
Lamalef(UNI_CHAR);
void 
BaseLvl(PICSPARAMRec, PUCB2V);
void 
ucics(PICSPARAMRec, PUCB2V);
void 
pass1(PICSPARAMRec, PUCB2V);
void 
pass2(PICSPARAMRec, PUCB2V);
void 
pass3(PICSPARAMRec, PUCB2V);
void 
pass4(PICSPARAMRec, PUCB2V);
void 
pass5(PICSPARAMRec, PUCB2V);
