/***********************************************************



((c) Copyright 2002 IBM. All Rights Reserved)." Licensed by IBM under the X license."

 COPYRIGHT AND PERMISSION NOTICE


Copyright (c) 2002 IBM Corporation

All rights reserved.

Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, and/or sell copies of the Software, and to permit persons
to whom the Software is furnished to do so, provided that the above
copyright notice(s) and this permission notice appear in all copies of
the Software and that both the above copyright notice(s) and this
permission notice appear in supporting documentation.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT
OF THIRD PARTY RIGHTS. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
HOLDERS INCLUDED IN THIS NOTICE BE LIABLE FOR ANY CLAIM, OR ANY SPECIAL
INDIRECT OR CONSEQUENTIAL DAMAGES, OR ANY DAMAGES WHATSOEVER RESULTING
FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

Except as contained in this notice, the name of a copyright holder
shall not be used in advertising or otherwise to promote the sale, use
or other dealings in this Software without prior written authorization
of the copyright holder.

X Window System is a trademark of The Open Group

******************************************************************/

static unsigned short impTab[19][13] =
{
/* B, S,  L,  R,  EN,  AN, ET, ES, CS,  W,  N, IL, Cond */
  /* 0 L0 text      */ {0, 0, 0, 3, 0, 1, 0, 0, 0, 0, 0, 0, 0},
  /* 1 L0+AN        */ {0, 0, 0, 3, 0, 1, 4, 2, 2, 4, 4, 2, 0},

  /* 2 L0+AN+cont   */ {0, 0, 0, 3, 0, 1, 4, 4, 4, 4, 4, 2, 1},

  /* 3 L1 text      */ {0, 0, 0, 3, 6, 1, 5, 4, 4, 4, 4, 1, 0},
  /* 4 L1 cont      */ {0, 0, 0, 3, 0x66, 0x61, 5, 4, 4, 4, 4, 1, 1},

  /* 5 L1+prefix    */ {0, 0, 0, 3, 0x66, 0x41, 5, 4, 4, 4, 4, 1, 1},

  /* 6 L1+EN        */ {0, 0, 0, 3, 6, 1, 8, 7, 7, 4, 4, 2, 0},

  /* 7 L1+EN+cont   */ {0, 0, 0, 3, 6, 0x41, 5, 4, 4, 4, 4, 2, 1},

  /* 8 L1+EN+suffix */ {0, 0, 0, 3, 6, 1, 5, 4, 4, 4, 4, 2, 0},
  /* 9 L0 text      */ {9, 9, 16, 9, 11, 14, 10, 9, 9, 9, 9, 0, 0},
  /* 10 L0+prefix   */ {9, 9, 0xB0, 9, 11, 0xAE, 0x8A, 9, 9, 9, 9, 0, 1},
  /* 11 L0+EN       */ {9, 9, 16, 9, 11, 14, 13, 12, 12, 9, 9, 1, 0},
  /* 12 L0+EN+cont  */ {9, 9, 0x30, 9, 11, 0x2E, 0x2A, 9, 9, 9, 9, 1, 1},
  /* 13 L0+EN+suffix */ {9, 9, 16, 9, 11, 14, 10, 9, 9, 9, 9, 1, 0},

  /* 14 L0+AN       */ {9, 9, 16, 9, 11, 14, 10, 9, 15, 9, 9, 1, 0},

  /* 15 L0+AN+cont  */ {9, 9, 0x30, 9, 0x2B, 14, 0x2A, 9, 9, 9, 9, 1, 1},
  /* 16 L1 text     */ {9, 9, 16, 9, 18, 14, 17, 17, 17, 17, 17, 1, 0},
  /* 17 L1+cont     */ {9, 9, 16, 9, 18, 0x2E, 17, 17, 17, 17, 17, 1, 1},
  /* 18 L1+EN       */ {9, 9, 16, 9, 18, 14, 16, 17, 17, 17, 17, 1, 0}
};

/*****************************************************************************/
/* Not Spacing characters */
/*-----------------------*/
static UNI_CHAR unichr[][2] = { /* 60, 2 */
                               {0x0300, 0x0385},
                               {0x0483, 0x0486},
                               {0x05B0, 0x05BD},
                               {0x05BF, 0x05BF},
                               {0x05C1, 0x05C2},
                               {0x05F5, 0x05F5},
                               {0x064B, 0x0652},
                               {0x0670, 0x0670},
                               {0x06D6, 0x06E4},
                               {0x06E7, 0x06E8},
                               {0x06EA, 0x06ED},
                               {0x0901, 0x0902},
                               {0x093C, 0x093C},
                               {0x0941, 0x0948},
                               {0x094D, 0x094D},
                               {0x0951, 0x0954},
                               {0x0962, 0x0963},
                               {0x0981, 0x0981},
                               {0x09BC, 0x09BC},
                               {0x09C1, 0x09C4},
                               {0x09CD, 0x09CD},
                               {0x09E2, 0x09E3},
                               {0x0A02, 0x0A02},
                               {0x0A3C, 0x0A3C},
                               {0x0A41, 0x0A4C},
                               {0x0A70, 0x0A71},
                               {0x0A81, 0x0A82},
                               {0x0ABC, 0x0ABC},
                               {0x0AC1, 0x0AC8},
                               {0x0ACD, 0x0ACD},
                               {0x0B01, 0x0B01},
                               {0x0B3C, 0x0B3C},
                               {0x0B3F, 0x0B3F},
                               {0x0B41, 0x0B43},
                               {0x0B4D, 0x0B4D},
                               {0x0BC0, 0x0BC0},
                               {0x0BCD, 0x0BCD},
                               {0x0C3E, 0x0C40},
                               {0x0C46, 0x0C56},
                               {0x0CBF, 0x0CBF},
                               {0x0CC6, 0x0CC6},
                               {0x0CCC, 0x0CCD},
                               {0x0D41, 0x0D43},
                               {0x0D4D, 0x0D4D},
                               {0x0E31, 0x0E31},
                               {0x0E34, 0x0E3A},
                               {0x0E47, 0x0E4D},
                               {0x0EB1, 0x0EB1},
                               {0x0EB4, 0x0EBC},
                               {0x0EC8, 0x0ECD},
                               {0x1026, 0x102A},
                               {0x102E, 0x102E},
                               {0x1030, 0x1030},
                               {0x1036, 0x1037},
                               {0x103B, 0x103B},
                               {0x103D, 0x103E},
                               {0x104B, 0x104C},
                               {0x20D0, 0x20FF},
                               {0x302A, 0x302F},
                               {0x3099, 0x309A}
};

/*****************************************************************************/
/* Symmetric Pairs */
/*-----------------*/
static UNI_CHAR unisymm[24][2] = {
                                  {0x0028, 0x0029},
                                  {0x0029, 0x0028},
                                  {0x003C, 0x003E},
                                  {0x003E, 0x003C},
                                  {0x005B, 0x005D},
                                  {0x005D, 0x005B},
                                  {0x007B, 0x007D},
                                  {0x007D, 0x007B},
                                  {0x00AB, 0x00BB},
                                  {0x00BB, 0x00AB},
                                  {0x207D, 0x207E},
                                  {0x207E, 0x207D},
                                  {0x208D, 0x208E},
                                  {0x208E, 0x208D},
                                  {0x2329, 0x232A},
                                  {0x232A, 0x2329},
                                  {0xFE59, 0xFE5A},
                                  {0xFE5A, 0xFE59},
                                  {0xFE5B, 0xFE5C},
                                  {0xFE5C, 0xFE5B},
                                  {0xFE5D, 0xFE5E},
                                  {0xFE5E, 0xFE5D},
                                  {0xFE64, 0xFE65},
                                  {0xFE65, 0xFE64}
};

/*****************************************************************************/
static unsigned short shapeTable[4][4][4] =
{
 {{0, 0, 0, 0}, {0, 0, 0, 0}, {0, 1, 0, 3}, {0, 1, 0, 1}},
 {{0, 0, 2, 2}, {0, 0, 1, 2}, {0, 1, 1, 2}, {0, 1, 1, 3}},
 {{0, 0, 0, 0}, {0, 0, 0, 0}, {0, 1, 0, 3}, {0, 1, 0, 3}},
 {{0, 0, 1, 2}, {0, 0, 1, 2}, {0, 1, 1, 2}, {0, 1, 1, 3}}};

/*****************************************************************************/
static unsigned short araLink[178] =
{
 1 + 32 + 256 * 0x11,
 1 + 32 + 256 * 0x13,
 1 + 256 * 0x15,
 1 + 32 + 256 * 0x17,
 1 + 2 + 256 * 0x19,
 1 + 32 + 256 * 0x1D,
 1 + 2 + 256 * 0x1F,
 1 + 256 * 0x23,
 1 + 2 + 256 * 0x25,
 1 + 2 + 256 * 0x29,
 1 + 2 + 256 * 0x2D,
 1 + 2 + 256 * 0x31,
 1 + 2 + 256 * 0x35,
 1 + 256 * 0x39,
 1 + 256 * 0x3B,
 1 + 256 * 0x3D,
 1 + 256 * 0x3F,
 1 + 2 + 256 * 0x41,
 1 + 2 + 256 * 0x45,
 1 + 2 + 256 * 0x49,
 1 + 2 + 256 * 0x4D,
 1 + 2 + 256 * 0x51,
 1 + 2 + 256 * 0x55,
 1 + 2 + 256 * 0x59,
 1 + 2 + 256 * 0x5D,
 0, 0, 0, 0, 0,                 /* 0x63B - 0x63F */
 1 + 2,
 1 + 2 + 256 * 0x61,
 1 + 2 + 256 * 0x65,
 1 + 2 + 256 * 0x69,
 1 + 2 + 16 + 256 * 0x6D,
 1 + 2 + 256 * 0x71,
 1 + 2 + 256 * 0x75,
 1 + 2 + 256 * 0x79,
 1 + 256 * 0x7D,
 1 + 256 * 0x7F,
 1 + 2 + 256 * 0x81,
 4, 4, 4, 4,
 4, 4, 4, 4,                    /* 0x64B - 0x652 */
 0, 0, 0, 0, 0,
 0, 0, 0, 0,                    /* 0x653 - 0x65B */
 1 + 256 * 0x85,
 1 + 256 * 0x87,
 1 + 256 * 0x89,
 1 + 256 * 0x8B,
 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0,              /* 0x660 - 0x66F */
 4,
 0,
 1 + 32,
 1 + 32,
 0,
 1 + 32,
 1, 1,
 1 + 2, 1 + 2, 1 + 2, 1 + 2, 1 + 2, 1 + 2,
 1 + 2, 1 + 2, 1 + 2, 1 + 2, 1 + 2, 1 + 2,
 1 + 2, 1 + 2, 1 + 2, 1 + 2,
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 1, 1, 1, 1, 1, 1, 1, 1,
 1 + 2, 1 + 2, 1 + 2, 1 + 2, 1 + 2, 1 + 2, 1 + 2, 1 + 2, 1 + 2, 1 + 2,
 1 + 2, 1 + 2, 1 + 2, 1 + 2, 1 + 2, 1 + 2, 1 + 2, 1 + 2, 1 + 2, 1 + 2,
 1 + 2, 1 + 2, 1 + 2, 1 + 2, 1 + 2, 1 + 2, 1 + 2, 1 + 2, 1 + 2, 1 + 2,
 1 + 2, 1 + 2, 1 + 2, 1 + 2, 1 + 2, 1 + 2, 1 + 2, 1 + 2,
 1,
 1 + 2,
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 1 + 2,
 1,
 1 + 2, 1 + 2, 1 + 2, 1 + 2,
 1, 1
};

/*****************************************************************************/
static unsigned short presLink[141] =
{
 4,
 1 + 2,
 4, 4, 4, 4, 4,
 1 + 2,
 4, 1 + 2, 4, 1 + 2,
 4, 1 + 2, 4, 1 + 2,
 0, 0 + 32, 1 + 32, 0 + 32,
 1 + 32, 0, 1, 0 + 32,
 1 + 32, 0, 2, 1 + 2,
 1, 0 + 32, 1 + 32, 0,
 2, 1 + 2, 1, 0,
 1, 0, 2, 1 + 2,
 1, 0, 2, 1 + 2,
 1, 0, 2, 1 + 2,
 1, 0, 2, 1 + 2,
 1, 0, 2, 1 + 2,
 1, 0, 1, 0,
 1, 0, 1, 0,
 1, 0, 2, 1 + 2,
 1, 0, 2, 1 + 2,
 1, 0, 2, 1 + 2,
 1, 0, 2, 1 + 2,
 1, 0, 2, 1 + 2,
 1, 0, 2, 1 + 2,
 1, 0, 2, 1 + 2,
 1, 0, 2, 1 + 2,
 1, 0, 2, 1 + 2,
 1, 0, 2, 1 + 2,
 1, 0, 2, 1 + 2,
 1, 0 + 16, 2 + 16, 1 + 2 + 16,
 1 + 16, 0, 2, 1 + 2,
 1, 0, 2, 1 + 2,
 1, 0, 2, 1 + 2,
 1, 0, 1, 0,
 1, 0, 2, 1 + 2,
 1, 0, 1, 0,
 1, 0, 1, 0,
 1
};

/*****************************************************************************/
static unsigned short ComtoNom[] =
{ /*  0      1      2      3      4      5      6      7      8      9      10 */
    0x621, 0x622, 0x622, 0x623, 0x623, 0x624, 0x624, 0x625, 0x625, 0x626, 0x626,
  /*  11     12     13     14     15     16     17     18     19     20     21 */  
    0x626, 0x626, 0x627, 0x627, 0x628, 0x628, 0x628, 0x628, 0x629, 0x629, 0x62A, 
  /*  22     23     24     25     26     27     28     29     30     31     32 */  
    0x62A, 0x62A, 0x62A, 0x62B, 0x62B, 0x62B, 0x62B, 0x62C, 0x62C, 0x62C, 0x62C,  
  /*  33     34     35     36     37     38     39     40     41     42     43 */  
    0x62D, 0x62D, 0x62D, 0x62D, 0x62E, 0x62E, 0x62E, 0x62E, 0x62F, 0x62F, 0x630, 
  /*  44     45     46     47     48     49     50     51     52     53     54 */  
    0x630, 0x631, 0x631, 0x632, 0x632, 0x633, 0x633, 0x633, 0x633, 0x634, 0x634, 
  /*  55     56     57     58     59     60     61     62     63     64     65 */  
    0x634, 0x634, 0x635, 0x635, 0x635, 0x635, 0x636, 0x636, 0x636, 0x636, 0x637, 
  /*  66     67     68     69     70     71     72     73     74     75     76 */  
    0x637, 0x637, 0x637, 0x638, 0x638, 0x638, 0x638, 0x639, 0x639, 0x639, 0x639,
  /*  77     78     79     80     81     82     83     84     85     86     87 */  
    0x63A, 0x63A, 0x63A, 0x63A, 0x641, 0x641, 0x641, 0x641, 0x642, 0x642, 0x642, 
  /*  88     89     90     91     92     93     94     95     96     97     98 */  
    0x642, 0x643, 0x643, 0x643, 0x643, 0x644, 0x644, 0x644, 0x644, 0x645, 0x645,
  /*  99     100    101    102    103    104    105    106    107    108    109*/  
    0x644, 0x645, 0x645, 0x645, 0x645, 0x646, 0x646, 0x646, 0x646, 0x647, 0x647, 
  /*  110    111    112    113    114    115    116    117    118    119    120*/  
    0x647, 0x647, 0x648, 0x648, 0x649, 0x649, 0x64A, 0x64A, 0x64A, 0x64A       
};

/*****************************************************************************/
static unsigned short PrestoNom[] =
{
/* 0        1       2       3           */
 0x064B, 0xFE71, 0x064C, 0xFE73,/* 0    */
 0x064D, 0xFE75, 0x064E, 0xFE77,/* 1    */
 0x064F, 0xFE79, 0x0650, 0xFE7b,/* 2    */
 0x0651, 0xFE7d, 0x0652, 0xFE7f,/* 3    */
 0x0621, 0x0622, 0xFE82, 0x0623,/* 10   */
 0xFE84, 0x0624, 0x0624, 0x0625,/* 11   */
 0xFE88, 0x0626, 0xFE8b, 0xFE8b,/* 12   */
 0x0626, 0x0627, 0xFE8e, 0x0628,/* 13   */
 0xFE91, 0xFE91, 0x0628, 0x0629,/* 20   */
 0x0629, 0x062A, 0xFE97, 0xFE97,/* 21   */
 0x062A, 0x062B, 0xFE9b, 0xFE9b,/* 22   */
 0x062B, 0x062C, 0xFE9F, 0xFE9F,/* 23   */
 0x062C, 0x062D, 0xFEa3, 0xFEa3,/* 30   */
 0x062D, 0x062E, 0xFEA7, 0xFEA7,/* 31   */
 0x062E, 0x062F, 0x062F, 0x0630,/* 32   */
 0x0630, 0x0631, 0x0631, 0x0632,/* 33   */
 0x0632, 0x0633, 0xFEb3, 0xFEb3,/* 100  */
 0x0633, 0x0634, 0xFEb7, 0xFEb7,/* 101  */
 0x0634, 0x0635, 0xFEbb, 0xFEbb,/* 102  */
 0x0635, 0x0636, 0xFEbf, 0xFEbf,/* 103  */
 0x0636, 0x0637, 0x0637, 0x0637,/* 110  */
 0x0637, 0x0638, 0x0638, 0x0638,/* 111  */
 0x0638, 0x0639, 0xFEcb, 0xFEcc,/* 112  */
 0xFEca, 0x063A, 0xFEcf, 0xFEd0,/* 113  */
 0xFEce, 0x0641, 0xFEd3, 0xFEd3,/* 120  */
 0x0641, 0x0642, 0xFEd7, 0xFEd7,/* 121  */
 0x0642, 0x0643, 0xFEdb, 0xFEdb,/* 122  */
 0x0643, 0x0644, 0xFEdf, 0xFEdf,/* 123  */
 0x0644, 0x0645, 0xFEe3, 0xFEe3,/* 130  */
 0x0645, 0x0646, 0xFEe7, 0xFEe7,/* 131  */
 0x0646, 0xFEea, 0x0647, 0xFEec,/* 132  */
 0xFEea, 0x0648, 0x0648, 0x0649,/* 133  */
 0xFEf0, 0x064A, 0xFEf3, 0xFEf3,/* 200  */
 0xFEf2, 0xFEf5, 0xFEf6, 0xFEf7,/* 201  */
 0xFEf8, 0xFEf9, 0xFEfa, 0xFEfb,/* 202  */
 0xFEfc
};
