/***********************************************************



((c) Copyright 2002 IBM. All Rights Reserved)." Licensed by IBM under the X license."

 COPYRIGHT AND PERMISSION NOTICE


Copyright (c) 2002 IBM Corporation

All rights reserved.

Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, and/or sell copies of the Software, and to permit persons
to whom the Software is furnished to do so, provided that the above
copyright notice(s) and this permission notice appear in all copies of
the Software and that both the above copyright notice(s) and this
permission notice appear in supporting documentation.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT
OF THIRD PARTY RIGHTS. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
HOLDERS INCLUDED IN THIS NOTICE BE LIABLE FOR ANY CLAIM, OR ANY SPECIAL
INDIRECT OR CONSEQUENTIAL DAMAGES, OR ANY DAMAGES WHATSOEVER RESULTING
FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

Except as contained in this notice, the name of a copyright holder
shall not be used in advertising or otherwise to promote the sale, use
or other dealings in this Software without prior written authorization
of the copyright holder.

X Window System is a trademark of The Open Group


******************************************************************/

#include "uc_types.h"
#include "uc_tables.h"
/**************************** START OF SPECIFICATIONS ***********************/
/*                                                                          */
/*  SUBROUTINE NAME: Uba_Blk_Sep                                            */
/*                                                                          */
/*  DESCRIPTIVE NAME: Checks the Block separator character type.            */
/*                                                                          */
/*  FUNCTION: This function is called when we need to check whether a       */
/*            certain character belongs to this type. It returns TRUE       */
/*            when the character belongs to this type  and FALSE otherwise. */
/*                                                                          */
/*  ENTRY POINT: Uba_Blk_Sep                                                */
/*      LINKAGE: called from GetGroup (ics.c)                               */
/*                                                                          */
/*  INPUT: x            UNI_CHAR      The character to be checked           */
/*                                                                          */
/************************** END OF SPECIFICATIONS ***************************/
int 
Uba_S(x)
UNI_CHAR x;
{
    if (x == 0x0009)
        return (TRUE);
    return (FALSE);
}

/**************************** START OF SPECIFICATIONS ***********************/
/*                                                                          */
/*  SUBROUTINE NAME: Uba_Blk_Sep                                            */
/*                                                                          */
/*  DESCRIPTIVE NAME: Checks the Block separator character type.            */
/*                                                                          */
/*  FUNCTION: This function is called when we need to check whether a       */
/*            certain character belongs to this type. It returns TRUE       */
/*            when the character belongs to this type  and FALSE otherwise. */
/*                                                                          */
/*  ENTRY POINT: Uba_Blk_Sep                                                */
/*      LINKAGE: called from GetGroup (ics.c)                               */
/*                                                                          */
/*  INPUT: x            UNI_CHAR      The character to be checked           */
/*                                                                          */
/************************** END OF SPECIFICATIONS ***************************/
int 
Uba_Blk_Sep(x)
UNI_CHAR x;
{
    if (x == 0x2029)
        return (TRUE);
    return (FALSE);
}

/**************************** START OF SPECIFICATIONS ***********************/
/*                                                                          */
/*  SUBROUTINE NAME: Uba_LTR                                                */
/*                                                                          */
/*  DESCRIPTIVE NAME: Checks the Left to Right character type.              */
/*                                                                          */
/*  FUNCTION: This function is called when we need to check whether a       */
/*            certain character belongs to this type. It returns TRUE       */
/*            when the character belongs to this type  and FALSE otherwise. */
/*                                                                          */
/*  ENTRY POINT: Uba_LTR                                                    */
/*      LINKAGE: called from GetGroup (ics.c)                               */
/*                                                                          */
/*  INPUT: x            UNI_CHAR      The character to be checked           */
/*                                                                          */
/************************** END OF SPECIFICATIONS ***************************/
int 
Uba_LTR(x)
UNI_CHAR x;
{
  if( ((x > 0x0040) && (x <= 0x005A)) ||
      ((x >= 0x0061) && (x <= 0x007A)) || ((x >= 0x00C0) && (x <= 0x00D6)) ||
      ((x >= 0x00D8) && (x <= 0x00F6)) || ((x >= 0x00F8) && (x <= 0x058F)) ||
      ((x >= 0x0900) && (x <= 0x10FF)) ||
      (x == 0x200E) ||
      ((x >= 0x20D0) && (x <= 0x20FF)) || ((x >= 0x2160) && (x <= 0x2182)) ||
      ((x >= 0x3040) && (x <= 0x9FFF)) || ((x >= 0xF900) && (x <= 0xFB17)) ||
      (x == 0xFE60) || (x == 0xFE6B) || (x == 0xFF06) ||
      ((x >= 0xFF20) && (x <= 0xFF3A)) || ((x >= 0xFF41) && (x <= 0xFF5A)) ||
      ((x >= 0xFF60) && (x <= 0xFFDF))  )
    return(TRUE);
  return(FALSE);
}

/**************************** START OF SPECIFICATIONS ***********************/
/*                                                                          */
/*  SUBROUTINE NAME: Uba_RTL                                                */
/*                                                                          */
/*  DESCRIPTIVE NAME: Checks the Right to left character type.              */
/*                                                                          */
/*  FUNCTION: This function is called when we need to check whether a       */
/*            certain character belongs to this type. It returns TRUE       */
/*            when the character belongs to this type  and FALSE otherwise. */
/*                                                                          */
/*  ENTRY POINT: Uba_RTL                                                    */
/*      LINKAGE: called from GetGroup (ics.c)                               */
/*                                                                          */
/*  INPUT: x            UNI_CHAR      The character to be checked           */
/*                                                                          */
/************************** END OF SPECIFICATIONS ***************************/
int 
Uba_RTL(x)
UNI_CHAR x;
{
  if( ((x >= 0x0590) && (x <= 0x0650)) || ((x >= 0x066E) && (x <= 0x06EF)) ||
      ((x >= 0x06FA) && (x >= 0x08FF)) || (x == 0x200F) ||
      ((x >= 0xFB20) && (x <= 0xFDFF)) || ((x >= 0xFE70) && (x <= 0xFEF7)) )
    return(TRUE);
  return(FALSE);
}


/**************************** START OF SPECIFICATIONS ***********************/
/*                                                                          */
/*  SUBROUTINE NAME: Uba_EN                                                 */
/*                                                                          */
/*  DESCRIPTIVE NAME: Checks the European digit character type.             */
/*                                                                          */
/*  FUNCTION: This function is called when we need to check whether a       */
/*            certain character belongs to this type. It returns TRUE       */
/*            when the character belongs to this type  and FALSE otherwise. */
/*                                                                          */
/*  ENTRY POINT: Uba_EN                                                     */
/*      LINKAGE: called from GetGroup (ics.c)                               */
/*                                                                          */
/*  INPUT: x            UNI_CHAR      The character to be checked           */
/*                                                                          */
/************************** END OF SPECIFICATIONS ***************************/

int 
Uba_EN(x)
UNI_CHAR x;
{
  if( ((x >= 0x0030) && (x <= 0x0039)) || ((x >= 0x00B2) && (x <= 0x00B3)) ||
      (x == 0x00B9) ||
      ((x >= 0x00BC) && (x <= 0x00BE)) || 
      (x == 0x2070) ||
      ((x >= 0x2074) && (x <= 0x2079)) || ((x >= 0x2080) && (x <= 0x2089)) ||
      ((x >= 0x2153) && (x <= 0x2182)) || ((x >= 0xFF10) && (x <= 0xFF19)) )
    return(TRUE);
  return(FALSE);
}

/**************************** START OF SPECIFICATIONS ***********************/
/*                                                                          */
/*  SUBROUTINE NAME: Uba_AN                                                 */
/*                                                                          */
/*  DESCRIPTIVE NAME: Checks the Arabic-Indic digit character type.         */
/*                                                                          */
/*  FUNCTION: This function is called when we need to check whether a       */
/*            certain character belongs to this type. It returns TRUE       */
/*            when the character belongs to this type  and FALSE otherwise. */
/*                                                                          */
/*  ENTRY POINT: Uba_AN                                                     */
/*      LINKAGE: called from GetGroup (ics.c)                               */
/*                                                                          */
/*  INPUT: x            UNI_CHAR      The character to be checked           */
/*                                                                          */
/************************** END OF SPECIFICATIONS ***************************/

int 
Uba_AN(x)
UNI_CHAR x;
{
    if (((x >= 0x0660) && (x <= 0x0669)) || ((x >= 0x066B) && (x <= 0x66C)) ||
        ((x >= 0x06F0) && (x <= 0x06F9)))
        return (TRUE);
    return (FALSE);
}

/**************************** START OF SPECIFICATIONS ***********************/
/*                                                                          */
/*  SUBROUTINE NAME: Uba_ET                                                 */
/*                                                                          */
/*  DESCRIPTIVE NAME: Checks the European digit terminator character type.  */
/*                                                                          */
/*  FUNCTION: This function is called when we need to check whether a       */
/*            certain character belongs to this type. It returns TRUE       */
/*            when the character belongs to this type  and FALSE otherwise. */
/*                                                                          */
/*  ENTRY POINT: Uba_ET                                                     */
/*      LINKAGE: called from GetGroup (ics.c)                               */
/*                                                                          */
/*  INPUT: x            UNI_CHAR      The character to be checked           */
/*                                                                          */
/************************** END OF SPECIFICATIONS ***************************/
int 
Uba_ET(x)
UNI_CHAR x;
{
    if ( ((x >= 0x0023) &&  (x <= 0x0025)) || (x == 0x002B)  || (x == 0x002D)  || ((x >= 0x00A2) &&  (x <= 0x00A5)) || 
	 ((x >= 0x00B0) &&  (x <= 0x00B1)) || (x == 0x066A)  || ((x >= 0x2030) && (x <= 0x2033)) || ((x >= 0x207A)  &&  
         (x <= 0x207B)) ||  ((x >= 0x208A) && (x <= 0x208B)) || ((x >= 0x20A0) && (x <= 0x20CF)) || ((x >= 0x2212)  &&  
         (x <= 0x2213)) || (x == 0xFE5F)   || ((x >= 0xFE62) && (x >= 0xFE63)) || ((x >= 0xFE69) &&  (x <= 0xFE6A)) || 
	 ((x >= 0xFF03) && (x >= 0xFF05))  || (x == 0xFF0B)  || (x == 0xFF0D)  || ((x >= 0xFFE0) &&  (x <= 0xFFE1)) || 
	 ((x >= 0xFFE5) && (x <= 0xFFE6)))
        return (TRUE);
    return (FALSE);
}

/**************************** START OF SPECIFICATIONS ***********************/
/*                                                                          */
/*  SUBROUTINE NAME: Uba_ES                                                 */
/*                                                                          */
/*  DESCRIPTIVE NAME: Checks the European digit separator character type.   */
/*                                                                          */
/*  FUNCTION: This function is called when we need to check whether a       */
/*            certain character belongs to this type. It returns TRUE       */
/*            when the character belongs to this type  and FALSE otherwise. */
/*                                                                          */
/*  ENTRY POINT: Uba_ES                                                     */
/*      LINKAGE: called from GetGroup (ics.c)                               */
/*                                                                          */
/*  INPUT: x            UNI_CHAR      The character to be checked           */
/*                                                                          */
/************************** END OF SPECIFICATIONS ***************************/
int 
Uba_ES(x)
UNI_CHAR x;
{
    if ((x == 0x002F) ||
        (x == 0xFE52) ||
        ((x >= 0xFF0E) && (x <= 0xFF0F)))
        return (TRUE);
    return (FALSE);
}

/**************************** START OF SPECIFICATIONS ***********************/
/*                                                                          */
/*  SUBROUTINE NAME: Uba_CS                                                 */
/*                                                                          */
/*  DESCRIPTIVE NAME: Checks the Common digit separator character type.     */
/*                                                                          */
/*  FUNCTION: This function is called when we need to check whether a       */
/*            certain character belongs to this type. It returns TRUE       */
/*            when the character belongs to this type  and FALSE otherwise. */
/*                                                                          */
/*  ENTRY POINT: Uba_CS                                                     */
/*      LINKAGE: called from GetGroup (ics.c)                               */
/*                                                                          */
/*  INPUT: x            UNI_CHAR      The character to be checked           */
/*                                                                          */
/************************** END OF SPECIFICATIONS ***************************/
int 
Uba_CS(x)
UNI_CHAR x;
{
    if ((x == 0x002C) || (x == 0x002E) || (x == 0x003A) || (x == 0x2007) ||
        (x == 0xFE50) || (x == 0xFE55) || (x == 0xFF0C) || (x == 0xFF1A))
        return (TRUE);
    return (FALSE);
}

/**************************** START OF SPECIFICATIONS ***********************/
/*                                                                          */
/*  SUBROUTINE NAME: Uba_W                                                  */
/*                                                                          */
/*  DESCRIPTIVE NAME: Checks the White character type.                      */
/*                                                                          */
/*  FUNCTION: This function is called when we need to check whether a       */
/*            certain character belongs to this type. It returns TRUE       */
/*            when the character belongs to this type  and FALSE otherwise. */
/*                                                                          */
/*  ENTRY POINT: Uba_W                                                      */
/*      LINKAGE: called from GetGroup (ics.c)                               */
/*                                                                          */
/*  INPUT: x            UNI_CHAR      The character to be checked           */
/*                                                                          */
/************************** END OF SPECIFICATIONS ***************************/
int 
Uba_W(x)
UNI_CHAR x;
{
    if ((x == 0x0020) || (x == 0x00A0) || ((x >= 0x2000) && (x <= 0x2006)) || ((x >= 0x2008) && (x <= 0x200B)) || (x == 0x3000))
        return (TRUE);
    return (FALSE);
}

/**************************** START OF SPECIFICATIONS ***********************/
/*                                                                          */
/*  SUBROUTINE NAME: Uba_BD                                                 */
/*                                                                          */
/*  DESCRIPTIVE NAME: Checks the Bidi special codes character type.         */
/*                                                                          */
/*  FUNCTION: This function is called when we need to check whether a       */
/*            certain character belongs to this type. It returns TRUE       */
/*            when the character belongs to this type  and FALSE otherwise. */
/*                                                                          */
/*  ENTRY POINT: Uba_BD                                                     */
/*      LINKAGE: called from GetGroup (ics.c)                               */
/*                                                                          */
/*  INPUT: x            UNI_CHAR      The character to be checked           */
/*                                                                          */
/************************** END OF SPECIFICATIONS ***************************/
int 
Uba_BD(x)
UNI_CHAR x;
{
    if (((x >= 0x202A) && (x <= 0x202E)) || ((x >= 0x206C) && (x <= 0x206F)))
        return (TRUE);
    return (FALSE);
}

/*****************************************************************************/
int 
UCQSPAC(UNI_CHAR x)
{
    int             low, high, mid;

    low  = 0;
    high = 59;

    while (low < high) {
        mid = (low + high) / 2;
        if (x < unichr[mid][0])
            high = mid - 1;
        else if (x > unichr[mid][1])
            low = mid + 1;
        else
            return (FALSE);
    }
    return (TRUE);
}

/*****************************************************************************/
UNI_CHAR 
UCQSYMM(UNI_CHAR x)
{
    int             low, high, mid;

    low  = 0;
    high = 23;

    while (low < high) {
        mid = (low + high) / 2;
        if (x < unisymm[mid][0])
            high = mid - 1;
        else if (x > unisymm[mid][0])
            low = mid + 1;
        else
            return (unisymm[mid][1]);
    }
    x = (low == high && x == unisymm[low][0]) ? unisymm[low][1] : x;
    return (x);

}

/*****************************************************************************/
UNI_CHAR 
Lamalef(UNI_CHAR x)
{
    if (x == 0x0622)
        return (0x065C);
    else if (x == 0x0623)
        return (0x065D);
    else if (x == 0x0625)
        return (0x065E);
    else if (x == 0x0627)
        return (0x065F);
    else
        return (UNI_NULL);
}

/*****************************************************************************/
wchar_t 
uba_getLink(UNI_CHAR x)
{
    if (x >= 0x0622 && x <= 0x06D3)
        return (araLink[x - 0x0622]);
    else if (x == 0x200D)
        return (3);
    else if (x >= 0x206D && x <= 0x206F)
        return (4);
    else if (x >= 0xFE70 && x <= 0xFEFC)
        return (presLink[x - 0xFE70]);
    else
        return (0);

}
