/***********************************************************



((c) Copyright 2002 IBM. All Rights Reserved)." Licensed by IBM under the X license."

 COPYRIGHT AND PERMISSION NOTICE


Copyright (c) 2002 IBM Corporation

All rights reserved.

Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, and/or sell copies of the Software, and to permit persons
to whom the Software is furnished to do so, provided that the above
copyright notice(s) and this permission notice appear in all copies of
the Software and that both the above copyright notice(s) and this
permission notice appear in supporting documentation.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT
OF THIRD PARTY RIGHTS. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
HOLDERS INCLUDED IN THIS NOTICE BE LIABLE FOR ANY CLAIM, OR ANY SPECIAL
INDIRECT OR CONSEQUENTIAL DAMAGES, OR ANY DAMAGES WHATSOEVER RESULTING
FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

Except as contained in this notice, the name of a copyright holder
shall not be used in advertising or otherwise to promote the sale, use
or other dealings in this Software without prior written authorization
of the copyright holder.

X Window System is a trademark of The Open Group


******************************************************************/

#include <stdlib.h>
#include <sys/types.h>

enum UBATYPE {
    UBAT_B,                     /* block separator           */
    UBAT_S,                     /* segment separator         */
    UBAT_L,                     /* left to right             */
    UBAT_R,                     /* right to left             */
    UBAT_EN,                    /* european digit            */
    UBAT_AN,                    /* Arabic-Indic digit        */
    UBAT_ET,                    /* european digit terminator */
    UBAT_ES,                    /* european digit separator  */
    UBAT_CS,                    /* common digit separator    */
    UBAT_W,                     /* white space               */
    UBAT_N,                     /* neutral                   */
    UBAT_BD                     /* bidi special codes        */
};

typedef wchar_t UNI_CHAR;
typedef enum UBATYPE UBA_TYPE;
typedef short   UBA_LEVEL;
typedef unsigned long UBA_STATE;
typedef UNI_CHAR *PUNI_CHAR;

#define UNI_NULL   ((UNI_CHAR)0)
#define TRUE       1
#define FALSE      0
#define LTR        0
#define RTL        1
#define ITIL      11
#define ITCOND    12
#define LINKR      1
#define LINKL      2
#define IRRELEVANT 4
#define LAMTYPE   16
#define ALEFTYPE  32
